/* services.js - API library for services configuration */

/* Copyright 2010 - 2013 TeamF1, Inc. */

function serviceAddFormValidate ()
	{
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Enter a valid service name';
    var errMsgL10n2 = 'Invalid ICMP Type - Please enter a value between 0 - 40';
    var errMsgL10n3 = 'Invalid ICMP Type';
    var errMsgL10n4 = 'Invalid Start Port - Please enter a value between 1-65535';    
    var errMsgL10n5 = 'Invalid Start Port';    
    var errMsgL10n6 = 'Invalid End Port - Please enter a value between 1-65535'    
    var errMsgL10n7 = 'Invalid End Port';    
    var errMsgL10n8 = 'Invalid range of ports';    
    var errMsgL10n9 = 'End service port'    
    var errMsgL10n10 = 'should be greater than start service port';    
    /* L10N Error Message Collection End */
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtAddCustServName,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtAddCustServIcmpType,"+ errMsgL10n3;
    txtFieldIdArr[2] = "txtAddCustServStartPort,"+ errMsgL10n5;
    txtFieldIdArr[3] = "txtAddCustServEndPort,"+ errMsgL10n7;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;
    
    if (icmpTypeRangeCheck () == false)
        return false;
         
	var obj = null;
    var startPort = 0;
	/* get and validate start port */
	obj = document.getElementById('txtAddCustServStartPort');
	if (portValueRangeCheck (obj, 1, 65535, '', null, true, "Invalid 'Start Port'.") == false)
         return false;
     if (!obj.disabled)
        startPort = obj.value;
    else
        startPort = 0;
	/* get and validate end port */
	var objEnd = document.getElementById('txtAddCustServEndPort');
	if (portValueRangeCheck (objEnd, 1, 65535, '', null, true, "Invalid 'Finish Port'.") == false)
         return false;
	if (!objEnd.disabled && (parseInt (objEnd.value, 10) < parseInt (startPort, 10)))
        {
        alert (errMsgL10n8 + ". " + errMsgL10n9+" (" + objEnd.value +
               ") "+ errMsgL10n10+" (" +startPort + ")");
        objEnd.focus ();
        return false;
        }
    var maxLimitObj = document.getElementById ('hdMaxLimitVal');
    var maxLimitVal = parseInt (maxLimitObj.value, 10);
    if(maxCountCheck ('hdCount', maxLimitVal, 'tblErrMsg') == false)
		return false;    
    return true;
	}
	
function checkServiceType ()
	{
	var selectedValue = comboSelectedValueGet ('selTwKeyServiceProtoType');
	if (!selectedValue) return;
	switch (parseInt (selectedValue, 10))
		{
		case 1:	 /* ICMP*/
		case 58: /*ICMPV6*/
			fieldStateChangeWr ('txtAddCustServStartPort txtAddCustServEndPort','','txtAddCustServIcmpType','');
			break;
		default:	/* TCP | UDP */
			fieldStateChangeWr ('txtAddCustServIcmpType','','txtAddCustServStartPort txtAddCustServEndPort','');
			break;
		}
	}
function icmpTypeRangeCheck ()
	{
	var icmpObj = document.getElementById('txtAddCustServIcmpType');
	var selectedValue = comboSelectedValueGet ('selTwKeyServiceProtoType');
	if (parseInt (selectedValue, 10) == 1)
		return numericValueRangeCheck (icmpObj, '', '', 0, 40, true, '', '');
	if (parseInt (selectedValue, 10) == 58)
		return numericValueRangeCheck (icmpObj, '', '', 1, 255, true, '', '');
	return true;
	}	
