/* trafficMeter.js - API library for Traffic Meter LAN configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
10b,07OCT10,hb written.
*/

function tfMeterDirCheck ()
	{
	var selValue = comboSelectedValueGet("selTMeterDir");
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO Limit */
			fieldStateChangeWr ('txtMonthlyLimit','','','');
			break;
		case 1:	/* Download Only */
		case 2:	/* Both Directions */
		default: /*  */
			fieldStateChangeWr ('','','txtMonthlyLimit','');			
			break;
		}
	}    
function trafficCounterTimerCheck ()
	{
	var selValue = radioCheckedValueGet ('FwTrafficMeterLan.RestartCounter');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 1:	/* NOW */
		    fieldStateChangeWr ('','','txtSpecificTimeHr txtSpecificTimeMin selSpecificTimeMeridian selSpecificTimeDay','');			
			break;
		default: /* SPECIFIC TIME */
			fieldStateChangeWr ('txtSpecificTimeHr txtSpecificTimeMin selSpecificTimeMeridian selSpecificTimeDay','','','');
			break;
		}
	}



function lanTrafficMeterValidate ()
    {    
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a monthly limit (in MB) for the traffic';
    var errMsgL10n2 = "Please specify by how much the current month's limit (in MB) should be increased";
    var errMsgL10n3 = 'Invalid restart time for counter - Enter valid hour between 1 and 12';
    var errMsgL10n4 = 'Invalid restart time for counter.';
    var errMsgL10n5 = 'Invalid restart time for counter - Enter valid minutes between 0 and 59';
    var errMsgL10n6 = 'Invalid Monthly Limit. ';
    var errMsgL10n7 = 'Invalid Increase Month Limit. ';
    var errMsgL10n8 = 'MB';
     /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtMonthlyLimit,"+errMsgL10n1;
    txtFieldIdArr[1] = "txtIncrMonthlyLmt,"+errMsgL10n2;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    var ipAddrObj = document.getElementById('tblLanSetupIpAddr');
    if (ipAddrObj.type != "hidden")   
	if (ipv4AddrOctetsValidate ('tblLanSetupIpAddr', 'IPD', false, true,
             "Invalid IP address.", "for octet ", true) == false)
    	return false;
         
	var monLimitObj = document.getElementById('txtMonthlyLimit');
	if (numericValueRangeCheck (monLimitObj , '', '', 0, 256000, true, errMsgL10n6, errMsgL10n8) == false)
        return false;
	var incMonLimitObj = document.getElementById('txtIncrMonthlyLmt');
	if (numericValueRangeCheck (incMonLimitObj, '', '', 0, 256000, true, errMsgL10n7, errMsgL10n8) == false)
        return false;

    var timeObj = document.getElementById('txtSpecificTimeHr');
	if (numericValueRangeCheck (timeObj , 1, 
                            errMsgL10n3,
                            1, 12, true, errMsgL10n4, "") == false)
        return false;
    timeObj = document.getElementById('txtSpecificTimeMin');
	if (numericValueRangeCheck (timeObj , 1, 
                            errMsgL10n5,
                            0, 59, true,errMsgL10n4, "") == false)
        return false;
    return true;          
    }
function trafficMeterInit ()
	{
	tfMeterDirCheck();
	trafficCounterTimerCheck ();
	}
